import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const ancientMineshaftSpawner = [
    "nicothekid:structure_mineshaft_ancient",
    "nicothekid:structure_msa_arch_way_east",
    "nicothekid:structure_msa_arch_way_north",
    "nicothekid:structure_msa_arch_way_south",
    "nicothekid:structure_msa_arch_way_west",
    "nicothekid:structure_msa_way_east",
    "nicothekid:structure_msa_way_north",
    "nicothekid:structure_msa_way_south",
    "nicothekid:structure_msa_way_west"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:ancient_mineshaft_spawner_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (ancientMineshaftSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_ancient")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/am_center_01" ${blockLocation.x - 18} ${blockLocation.y - 3} ${blockLocation.z - 18}`);
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_02" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_03" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_04" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_05" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_11" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_12" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_11" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_12" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_11" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_12" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_07" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_08" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_09" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_10" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_11" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_12" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_02" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_03" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_04" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_05" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:ancient_mineshaft_spawner_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (ancientMineshaftSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_ancient")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/am_center_01" ${blockLocation.x - 18} ${blockLocation.y - 3} ${blockLocation.z - 18}`);
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_north_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_arched_way_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_02" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_03" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_04" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_05" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_11" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_east_12" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_11" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_north_12" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_11" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_south_12" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_07" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_08" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_09" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_10" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_11" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_way_west_12" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_02" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_03" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_04" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_05" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
});