import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const birchWoodMineshaftSpawner = [
    "nicothekid:structure_mineshaft_birch",
    "nicothekid:structure_msb_ground_way_east",
    "nicothekid:structure_msb_ground_way_north",
    "nicothekid:structure_msb_ground_way_south",
    "nicothekid:structure_msb_ground_way_west",
    "nicothekid:structure_msb_way_east",
    "nicothekid:structure_msb_way_north",
    "nicothekid:structure_msb_way_south",
    "nicothekid:structure_msb_way_west"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:birch_wood_mineshaft_spawner_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (birchWoodMineshaftSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_birch")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/bwm_main_01" ${blockLocation.x - 4} ${blockLocation.y - 31} ${blockLocation.z - 5}`);
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_02" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_03" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_04" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_02" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_03" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_04" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_09" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_10" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_trial_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_05" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_06" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_trial_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_09" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_10" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_05" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_06" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_trial_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_03" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_04" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_06" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_07" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_08" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_09" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_10" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_03" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_04" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_06" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_trial_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:birch_wood_mineshaft_spawner_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (birchWoodMineshaftSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_birch")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/bwm_main_01" ${blockLocation.x - 4} ${blockLocation.y - 31} ${blockLocation.z - 5}`);
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_02" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_03" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_04" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_02" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_03" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_04" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_09" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_10" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_trial_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_05" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_06" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_trial_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_09" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_10" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_05" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_06" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_trial_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_03" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_04" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_06" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_07" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_08" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_09" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_10" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_03" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_04" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_06" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_trial_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
});