import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const oakWoodMineshaftSpawner = [
    "nicothekid:structure_mineshaft_oak",
    "nicothekid:structure_mso_ground_way_east",
    "nicothekid:structure_mso_ground_way_north",
    "nicothekid:structure_mso_ground_way_south",
    "nicothekid:structure_mso_ground_way_west",
    "nicothekid:structure_mso_way_east",
    "nicothekid:structure_mso_way_north",
    "nicothekid:structure_mso_way_south",
    "nicothekid:structure_mso_way_west"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:oak_wood_mineshaft_spawner_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (oakWoodMineshaftSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_oak")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/owm_center_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_south_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_01" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_02" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_03" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_04" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_west_02" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_south_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_01" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_02" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_03" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_04" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_05" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_06" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_07" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_08" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_09" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_10" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_west_02" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:oak_wood_mineshaft_spawner_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (oakWoodMineshaftSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_oak")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/owm_center_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_south_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_01" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_02" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_03" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_04" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_west_02" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_south_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_01" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_02" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_03" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_04" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_05" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_06" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_07" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_08" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_09" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_10" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_west_02" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
});