import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const spruceWoodMineshaftSpawner = [
    "nicothekid:structure_mineshaft_spruce",
    "nicothekid:structure_mss_way_east",
    "nicothekid:structure_mss_way_north",
    "nicothekid:structure_mss_way_south",
    "nicothekid:structure_mss_way_west"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:spruce_wood_mineshaft_spawner_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (spruceWoodMineshaftSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_spruce")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/swm_center_01" ${blockLocation.x - 14} ${blockLocation.y - 1} ${blockLocation.z - 14}`);
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_11" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_12" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_11" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_12" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_02" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_03" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_04" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_11" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_12" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_02" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_03" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_04" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 27) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_07" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_08" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_09" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 54) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_10" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_11" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_12" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:spruce_wood_mineshaft_spawner_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (spruceWoodMineshaftSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_spruce")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/swm_center_01" ${blockLocation.x - 14} ${blockLocation.y - 1} ${blockLocation.z - 14}`);
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_11" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_12" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_11" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_12" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_02" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_03" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_04" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_11" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_12" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_02" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_03" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_04" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 27) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_07" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_08" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_09" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 54) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_10" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_11" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_12" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
});